package hello;
 
import java.io.*;
import java.net.*;
 
public class HelloService {
 
    // port to listen
    public static int PORT = 8080;
 
    public static void main(String[] args) throws IOException {
         
        // load port settings from properties
        PORT = Integer.parseInt(System.getProperty("hello.service.port",
                String.valueOf(PORT)));
         
        // listen
        ServerSocket listener = new ServerSocket(PORT);
        System.out.println("HelloService started.");
         
        // accept a connection
        Socket socket;
        while(null != (socket = listener.accept())) {
             
            // open a thead to serve
            final Socket fsocket = socket;
            Thread t = new Thread(new Runnable() {
                 
                // A simple counter to let response changes
                int n = 1;
                 
                public void run() {
                     
                    try {
                        BufferedReader in = new BufferedReader(new InputStreamReader(
                                fsocket.getInputStream(), "iso-8859-1"));
                         
                        PrintStream out = new PrintStream(
                                new BufferedOutputStream(fsocket.getOutputStream()));
                         
                        // Get any http request
                        while(readHttpRequest(in)) {
                             
                            // Response a simple message
                            String msg = "<font color='red'>Hello, this is a demo service," +
                                    " you have requested " + n++ + " times.";
                             
                            out.println("HTTP/1.1 200 OK");
                            out.println("Content-Type: text/html; charset=iso-8859-1");
                            out.println("Content-Length: " + msg.length());
                            out.println();
                            out.println(msg);
                             
                            out.flush();
                        }
                         
                    }
                    catch (IOException e) {
                        e.printStackTrace();
                    }
                    finally {
                        try { fsocket.close(); } catch (IOException e) { }
                    }
                }
 
                // Get any http request
                private boolean readHttpRequest(BufferedReader in) {
                     
                    try {
                        String line;
                        while((line = in.readLine()) != null)
                        {
                            if(line.length() == 0) {
                                return true;
                            }
                        }
                    }
                    catch (IOException e) {
                    }
                     
                    return false;
                }
                 
            });
             
            t.setDaemon(true);
            t.start();
             
        }
         
    }
 
}